window.telerikWebReportDesignerInterop = {
    createWebReportDesignerWidget: function (designerElement, webReportDesignerOptionsString) {
        var webReportDesignerOptions = JSON.parse(webReportDesignerOptionsString);

        this.createEventHandlerReferences(webReportDesignerOptions);

        $(designerElement).telerik_WebReportDesigner(webReportDesignerOptions);
    },

    destroyWebReportDesignerWidget: function (designerElement) {
        // If you have issues with Blazor not clearing all the DOM generated through jQuery, you may need to do it yourself.
        // For example, widgets generating popup elements outside of the current container may remain in the DOM and
        // you may need to remove them yourself (e.g., before destroying the Kendo widgets, so you can use the references they offer).
        $(designerElement).empty();
    },

    findFunction: function (name) {
        var nameParts = name.replace(/^(window\.)/, "").split(".");
        var currentObject = window;
        while (currentObject && nameParts.length > 0) {
            currentObject = currentObject[nameParts.shift()];
        }

        return currentObject;
    },

    createEventHandlerReferences: function (webReportDesignerOptions) {
        for (var key in webReportDesignerOptions.clientEventsOptions) {
            var handlerName = webReportDesignerOptions.clientEventsOptions[key];
            webReportDesignerOptions[key] = this.findFunction(handlerName);
        }

        delete webReportDesignerOptions.clientEventOptions;
    },

};
